#ifndef _H_GAME_
#define _H_GAME_

#include "def.h"
#include "gint/gint.h"

typedef struct g_world g_world;
typedef struct g_player g_player;

struct g_player {
	f32 pos[ 3 ];		/* position */
	f32 ang[ 3 ];		/* angles */
	gi_mesh *mesh;		/* mesh */
	gi_mesh *mesh_gun;	/* gun mesh */
	uint texture;		/* texture id */
	bool fpm;		/* first pers. mode */
	f32 tgt[ 3 ];		/* view target */
	f32 jmp_h;
	f32 jmp_v;
	f32 gun_a;
	f32 gun_ang;
	f32 gun_time;
	int gun_mode;
};

struct g_world {
	f64 dta;		/* dt accum */
	int cetr_mx;		/* center on X */
	int cetr_my;		/* center on Y */
	gi_raw_img hmap;	/* height map */
	gi_mesh **mesh_map;	/* mesh */
	int map_w;		/* map width */
	int map_h;		/* map height */
	uint texture;		/* texture id */
	gi_mesh *sky_mesh;
	uint sky_tex;
	f32 sky_pos;
	gi_mesh *plane_mesh;	/*  */
	uint flare_tex;
	f32 cam[ 3 ];		/* camera pos */
	g_player ball;		/* player */
	bool win;
	gi_string *gstr_win;
};

g_world *g_world_create(	gi_font *font,
				const char *share,
				int map );
void g_world_delete( g_world *world );

void g_world_update(	g_world *world,
			gi_input *input,
			f64 dt );
void g_world_draw( g_world *world );

f32 g_world_get_h( g_world *world, f32 x, f32 y );
void g_world_get_point( g_world *world, f32 *beg, f32 *_ray, f32 *ret );

#endif /* _H_GAME_ */

