#ifndef _H_GIFONT_
#define _H_GIFONT_

#include "../def.h"

typedef struct gi_font gi_font;
typedef struct gi_string gi_string;

struct gi_font {
	uint tex_id;		/* textrure id */
	uint tex_size;		/* texture size */
	f32 char_sw;		/* width scaler */
};

struct gi_string {
	gi_font *font;		/* link to font */
	char *chars;		/* raw string */
	uint length;		/* it's length */
	void *vdata;		/* mesh vertexes */
	ui8 fcl[ 4 ];		/* rgba color */
	f32 fsize;		/* font size */
};

gi_font *gi_font_create( f32 ch_w, const char *png_file );
void gi_font_delete( gi_font *font );

gi_string *gi_string_create( gi_font *font, f32 size, const char *data );
void gi_string_update( gi_string *string, const char *data );
void gi_string_draw( gi_string *string );
void gi_string_draw_xy( gi_string *string, f32 x, f32 y );
void gi_string_delete( gi_string *string );

f32 gi_font_pxcalc( gi_font *font, uint px_size );
f32 gi_string_wcalc( gi_string *string );

#endif /* _H_GIFONT_ */

