#ifndef _H_GIMESH_
#define _H_GIMESH_

#include "gint.h"

#define GI_MESH_ISIZE	(2)
#define GI_MESH_VSIZE	(12+8+4)	/* vertex + texcoord + normal/color */

struct gi_mesh {
	ui16 vcount;			/* vertex count */
	ui16 icount;			/* index count */
	void *vdata;			/* vertex data */
	void *idata;			/* index data */
	bool light;			/* mesh have colors */
};

typedef struct gi_mesh gi_mesh;

gi_mesh* gi_mesh_load( const char *file );
gi_mesh* gi_mesh_create( 	ui16 vertex, ui16 index,
				void *v_data, void *i_data );
void gi_mesh_mklight(	gi_mesh *mesh,
			const i8 *dir,
			ui8 ambient );
void gi_mesh_draw( gi_mesh *mesh );
void gi_mesh_delete( gi_mesh *mesh );

#endif /* _H_GIMESH_ */

