#ifndef _H_GINT_
#define _H_GINT_

#include <GL/gl.h>
#include <GL/glext.h>

#include "../def.h"
#include "gint_types.h"

void gi_create();
void gi_delete();

void gi_get( uint name, void *value );

void gw_create( const char *title,
		int pos_x, int pos_y,
		int width, int height,
		gw_params *params );

void gw_change_title( const char *title );

void gw_delete();
void gw_swap_buffers();

bool gi_is_ext( const char *ext );
void *gi_ext_addr( const char *func_name );

gi_input *gi_input_update();

ui64 gi_timer_ui64();

#ifndef _GINT_INTERNAL_INCLUDE_
#include "gifont.h"
#include "gitools.h"
#include "giui.h"
#include "gimesh.h"
#endif

#endif /* _H_GINT_ */

