#ifndef _H_GITOOLS_
#define _H_GITOOLS_

#include "../def.h"

typedef struct gi_raw_img gi_raw_img;

struct gi_raw_img {
	int width;		/* image width */
	int height;		/* image height */
	ui8 *raw;		/* raw color data */
	bool alpha;		/* RGBA or RGB */
};

uint gi_img_load_png( const char *file, gi_raw_img *raw );
uint gi_img_load_bmp( const char *file, gi_raw_img *raw );
void gi_img_delete( uint id, gi_raw_img *raw );

void gi_ortho();
void gi_perspective(	f32 fov, f32 aspect,
			f32 znear, f32 zfar );
void gi_lookat( const f32 *pos,		/* position of camera */
		const f32 *tgt,		/* target poit */
		const f32 *up );	/* up vector */

#endif /* _H_GITOOLS_ */

