#ifndef _H_S_CONFIG_
#define _H_S_CONFIG_

#include "../def.h"
#include "map.h"

struct s_config {
	s_map *recs;		/* records of data */
	char *fname;		/* linked file */
};

typedef struct s_config s_config;

s_config *s_config_read( const char *file );
void s_config_write( s_config *conf );
s_config *s_config_create( const char *file );
void s_config_delete( s_config *conf );

const char *s_config_get_string( s_config *conf, const char *name );
int s_config_get_int( s_config *conf, const char *name );
f64 s_config_get_float( s_config *conf, const char *name );

void s_config_set_string( s_config *conf, const char *name, const char *val );
void s_config_set_int( s_config *conf, const char *name, int val );
void s_config_set_float( s_config *conf, const char *name, f64 val );

#endif /* _H_S_CONFIG_ */

