#ifndef _H_S_MAP_
#define _H_S_MAP_

#include "../def.h"

/* function	- compare two samples (indexes)
 * arguments	- two adresses of samples
 * return	- 0 when samples is equale, -1 if ind0 < ind1, ..
 */
typedef int ( *s_map_compare ) ( const void *ind0, const void *ind1 );

typedef struct s_map_node s_map_node;
typedef struct s_map s_map;

struct s_map_node {
	const void *index;		/* key */
	void *data;			/* value */
	s_map_node *left;		/* left branch */
	s_map_node *right;		/* right branch */
	s_map_node *top;		/* top node */
	int sign;			/* value for balance */
};

struct s_map {
	s_map_node *root;		/* root node */
	s_map_compare func;		/* compare function */
};

s_map *s_map_create( s_map_compare f );
void s_map_delete( s_map *map );
void *s_map_set( s_map *map, const void *index, void *data );
s_map_node *s_map_get( s_map *map, const void *index );

s_map_node *s_map_get_left( s_map *map );
s_map_node *s_map_get_right( s_map *map );
s_map_node *s_map_move_left( s_map *map, s_map_node *node );
s_map_node *s_map_move_right( s_map *map, s_map_node *node );

#endif /* _H_S_MAP_ */

