#ifndef _H_S_STACK_
#define _H_S_STACK_

#include <stdlib.h>
#include "../def.h"

#define S_STACK_ALLOC_BLOCK	32

struct s_stack {
	void **data;		/* elements string */
	int len;		/* number of elements */
	int alloc;		/* number of allocated places */
};

typedef struct s_stack s_stack;

INLINE s_stack *s_stack_create()
{
	s_stack *st = malloc( sizeof( s_stack ) );
	st->len = 0;
	st->alloc = S_STACK_ALLOC_BLOCK;
	st->data = malloc( sizeof( void* ) * st->alloc );

	return ( st );
}

INLINE void s_stack_delete( s_stack *st )
{
	free( st->data );
	free( st );
}

INLINE void s_stack_push( s_stack *st, void *el )
{
	if ( st->alloc <= st->len )
	{
		st->alloc += S_STACK_ALLOC_BLOCK;
		st->data = realloc( st->data, st->alloc * sizeof( void* ) );
	}
	
	st->data[ st->len++ ] = el;
}

INLINE void* s_stack_pop( s_stack *st )
{
	if ( st->len < 1 )
		return NULL;
	else
		return st->data[ --st->len ];
}

INLINE void* s_stack_get( s_stack *st )
{
	if ( st->len < 1 )
		return NULL;
	else
		return st->data[ st->len - 1 ];
}

#endif /* _H_S_STACK_ */

